<script setup lang="ts">
  const stylingMapping = {
    default: `transition shadow-1 outline-none relative block w-full
            text-(information base) sm:text-sm rounded-md border border-border bg-white font-medium
            placeholder:(font-normal text-information-subdued)
            focus:(ring-3 ring-primary ring-opacity-30 border-primary)
            hover:(ring-3 ring-primary ring-opacity-30 border-primary bg-interactive-hover)
            disabled:(bg-background-raised text-information-subdued placeholder:text-information-disabled)`,
    small: 'px-2 py-0.75',
    medium: 'px-3 py-1.5',
    large: 'px-3 py-2.25',
    area: 'py-2',
    error:
      'border-crimson-500 focus:(border-crimson-500 ring-3 ring-crimson-500 ring-opacity-30) hover:(ring-3 ring-crimson-500 ring-opacity-30 border-crimson-500)',
  };

  const props = withDefaults(
    defineProps<{
      size?: 'small' | 'medium' | 'large';
      modelValue?: string;
      textarea?: boolean;
      errors?: any[];
      type?: string;
      label?: string;
    }>(),
    {
      size: 'medium',
    },
  );

  const emit = defineEmits(['update:modelValue']);
  const $textfield = ref();

  const onChange = (e: any) => {
    emit('update:modelValue', e.target.value);
  };
  const componentType = computed(() => (props.textarea ? 'textarea' : 'input'));
  const computedClasses = computed(() => {
    return `${stylingMapping.default} ${stylingMapping[props.size]} ${
      props.textarea ? stylingMapping.area : ''
    } ${props.errors?.length ? stylingMapping.error : ''}`;
  });
</script>
<template>
  <div>
    <slot name="label">
      <SwLabel v-if="props.label" class="mb-1.5 block text-sm/6" @click="$textfield.focus()">
        {{ props.label }}
      </SwLabel>
    </slot>
    <Component
      :is="componentType"
      ref="$textfield"
      :value="modelValue"
      class="text-field"
      :class="computedClasses"
      :type="props.type"
      v-bind="$attrs"
      @input="onChange"
    />
    <slot name="errors"><SwError class="text-danger" :errors="props.errors" /></slot>
  </div>
</template>
